# to build the wrapper, call rpmbuild with --define="with_wrapper 1"
%define WITH_WRAPPER  %{?with_wrapper:%with_wrapper}%{!?with_wrapper:0}

%define baseversion 2.3.0
%define versionsuff 135
%define lib_versionsuff %{versionsuff}
%define tools_versionsuff 136

Name: libspe2
Version: %{baseversion}.%{versionsuff}
Release: 3%{?dist}
License: LGPL, GPL+
Group: System Environment/Base
URL: http://sourceforge.net/projects/libspe
Source: http://downloads.sourceforge.net/libspe/%{name}-%{baseversion}.%{lib_versionsuff}.tar.gz
Source2: elfspe
Source3: http://downloads.sourceforge.net/libspe/spu-tools-%{baseversion}.%{tools_versionsuff}.tar.gz
Source4: spu-tools-man.tar.bz2
Patch1: libspe-init.patch
Patch2: spu-tools-2.3.0.136-spufs-missing.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: ncurses-devel
Exclusivearch: ppc ppc64
Summary: SPE Runtime Management Library

%ifarch noarch
%define sysroot %{nil}
%define set_optflags %{nil}
%else
%define sysroot %{nil}
%define set_optflags OPTFLAGS="%{optflags}"
%endif

%ifarch ppc
%define _libdir %{_prefix}/lib
%endif
%ifarch ppc64
%define _libdir %{_prefix}/lib64
%endif
%define _includedir2 %{_prefix}/spu/include
%define _adaincludedir %{_prefix}/adainclude

%define _initdir /etc/init.d
%define _unpackaged_files_terminate_build 0

%if %{WITH_WRAPPER}
%package -n libspe
Summary: SPE Runtime Management Wrapper Library
Group: Development/Libraries
Requires: %{name} = %{version}
%endif

%package devel
Summary: SPE Runtime Management Library
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: libspe2 = %{version}-%{release}

%package ada
Summary: Ada binding for SPE Runtime Management Library
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: libspe2 = %{version}-%{release}

%if %{WITH_WRAPPER}
%package -n libspe-devel
Summary: SPE Runtime Management Library
Group: Development/Libraries
Requires: %{name} = %{version}
%endif

%ifarch ppc
%package -n elfspe2
Summary: Helper for standalong SPE applications
Group: Applications/System
Requires: %{name} = %{version}
Requires: libspe2 = %{version}-%{release}

%package -n spu-tools
Summary: User space tools for Cell/B.E.
Group: Applications/System
Requires: ncurses
%endif

%description
SPE Runtime Management Library for the
Cell Broadband Engine Architecture.

%if %{WITH_WRAPPER}
%description -n libspe
Header and object files for SPE Runtime
Management Wrapoer Library.
%endif

%description devel
Header and object files for SPE Runtime
Management Library.

%description ada
Ada specs for SPE Runtime Management Library.

%if %{WITH_WRAPPER}
%description -n libspe-devel
Header and object files for SPE Runtime
Management Library.
%endif

%ifarch ppc
%description -n elfspe2
This tool acts as a standalone loader for spe binaries.

%description -n spu-tools
The spu-tools package contains user space tools for Cell/B.E.
Currently, it contain two tools:
- spu-top: a tool like top to watch the SPU's on a Cell BE
System. It shows information about SPUs and running SPU contexts.
- spu-ps: a tool like ps, which dumps a report on the currently
running SPU contexts.
%endif

%prep
%setup -q -n %{name}-%{baseversion}
tar xvzf %{SOURCE3}
tar xvjf %{SOURCE4}
%patch1 -p1
%patch2 -p1

%build
make SYSROOT=%{sysroot} %{set_optflags} prefix=%{_prefix} libdir=%{_libdir}
%ifarch ppc
make elfspe-all SYSROOT=%{sysroot} %{set_optflags} prefix=%{_prefix} libdir=%{_libdir}
make -C spu-tools/src/ %{?_smp_mflags} spu-top spu-ps
%endif

%install
rm -rf $RPM_BUILD_ROOT%{sysroot}

make install DESTDIR=$RPM_BUILD_ROOT SYSROOT=%{sysroot} prefix=%{_prefix} libdir=%{_libdir} speinclude=%{_includedir2}
mkdir -p $RPM_BUILD_ROOT%{sysroot}%{_docdir}
mv $RPM_BUILD_ROOT%{sysroot}%{_adaincludedir}/README-libspe2 $RPM_BUILD_ROOT%{sysroot}%{_docdir}/README-ada
%ifarch ppc
make elfspe-install DESTDIR=$RPM_BUILD_ROOT SYSROOT=%{sysroot} prefix=%{_prefix} libdir=%{_libdir} speinclude=%{_includedir2}
make -C spu-tools/src/ install DESTDIR=$RPM_BUILD_ROOT
%endif

mkdir -p $RPM_BUILD_ROOT%{sysroot}%{_initdir}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{sysroot}/etc/init.d/elfspe

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%ifarch ppc
%preun -n elfspe2
if [ -f %{_initdir}/elfspe ]; then
   /sbin/chkconfig --del elfspe
fi

%post -n elfspe2
if [ -f %{_initdir}/elfspe ]; then
   /sbin/chkconfig --add elfspe
fi
if [ -f %{_bindir}/elfspe-register \
     -a -f /proc/sys/fs/binfmt_misc/register ]; then
   %{_bindir}/elfspe-register
fi
%endif

%files
%defattr(-,root,root)
%{sysroot}%{_libdir}/*2.so.*

%if %{WITH_WRAPPER}
%files -n libspe
%defattr(-,root,root)
%{sysroot}%{_libdir}/libspe.so.*
%endif

%files devel
%defattr(-,root,root)
%{sysroot}%{_libdir}/*2.so
%{sysroot}%{_libdir}/*2.a
%{sysroot}%{_libdir}/pkgconfig/*
%{sysroot}%{_includedir}/*2*.h
%{sysroot}%{_includedir}/cbea_map.h
%{sysroot}%{_includedir2}/*.h

%files ada
%defattr(-,root,root)
%{sysroot}%{_adaincludedir}/*
%{sysroot}%{_docdir}/README-ada

%if %{WITH_WRAPPER}
%files -n libspe-devel
%defattr(-,root,root)
%{sysroot}%{_libdir}/libspe.so
%{sysroot}%{_libdir}/libspe.a
%{sysroot}%{_includedir}/libspe.h
%endif

%ifarch ppc
%files -n elfspe2
%defattr(-,root,root)
%{sysroot}%{_bindir}/elfspe-register
%{sysroot}%{_bindir}/elfspe-unregister
%{sysroot}%{_bindir}/elfspe
%{sysroot}/etc/init.d/elfspe

%files -n spu-tools
%defattr(-,root,root)
%{sysroot}%{_bindir}/spu-top
%{sysroot}%{_bindir}/spu-ps
%{sysroot}%{_mandir}/man1/spu-top.1*
%{sysroot}%{_mandir}/man1/spu-ps.1*
%endif

%changelog
* Mon Jun 15 2009 Petr Machata <pmachata@redhat.com> - 2.3.0.135-3
- Revert the wrapper script to use #!/bin/bash again
- Resolves: #475637
- Resolves: #475619

* Wed Jun 10 2009 Petr Machata <pmachata@redhat.com> - 2.3.0.135-2
- Fix service wrapper script
- Handle the absence of SPU fs in spu-top
- Resolves: #475637
- Resolves: #475619

* Wed Mar  4 2009 Petr Machata <pmachata@redhat.com> - 2.3.0.135-1
- Rebase libspe to 2.3.0.135
  - Package Ada support in libspe2-ada subpackage
- Rebase spu-tools to 2.3.0.136
- Resolves: #475637
- Resolves: #475619

* Tue Nov 11 2008 Petr Machata <pmachata@redhat.com> - 2.2.80.121-4
- Rewrite scriptlets to if..then
- Resolves: #444969

* Wed Oct 22 2008 Petr Machata <pmachata@redhat.com> - 2.2.80.121-3
- Run elfspe-register only if the /proc/sys/fs/binfmt_misc/register
  file is available
- Resolves: #444969

* Fri Sep 19 2008 Petr Machata <pmachata@redhat.com> - 2.2.80.121-2
- Fix spec file per rpmdiff comments.
- Fix license info
- Related: #439447

* Tue Aug 12 2008 Petr Machata <pmachata@redhat.com> - 2.2.80.121-1
- Rebase libspe to 2.2.80-121
- Integrate spu-tools as new package into RHEL5.3
- Resolves: #439491
- Resolves: #439447

* Tue Jun  3 2008 Petr Machata <pmachata@redhat.com> - 2.2.80.95-2
- Run elfspe-register only if the /proc/sys/fs/binfmt_misc directory
  is available
- Resolves: #444969

* Wed Dec 19 2007 Petr Machata <pmachata@redhat.com> - 2.2.80.95-1
- Point URLs to SourceForge.
- Rebase to 2.2.80-95
- Resolves: #253213

* Thu Aug 16 2007 Petr Machata <pmachata@redhat.com> - 2.2.0.85-1
- Rebase to 2.2.0-85
- Resolves: #228307

* Tue Jun 26 2007 - Balint Cristian <cbalint@redhat.com> 2.1.0-2
- Initial RHEL-5 import.
- Related: rhbz228307

* Fri Jun 22 2007 - Petr Machata <pmachata@redhat.com> 2.1.0-1
- Initial RHEL package.

* Thu Nov 24 2005 - Arnd Bergmann <arnd@arndb.de> 1.0.1-3
- initial spec file for fc5
